package fxTavaranPaikka;

import fi.jyu.mit.fxgui.ModalController;
//import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.fxml.FXML;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.ButtonBar.ButtonData;
import javafx.scene.control.ButtonType;
import javafx.scene.control.ChoiceBox;
import javafx.scene.layout.GridPane;
import java.net.URL;
import java.util.Optional;

import fi.jyu.mit.fxgui.Dialogs;


/**
 * @author lpjsilve, alilakj
 * @version 15.2.2024
 * Ohjelman pääkontrolleri.
 */
public class TavaranPaikkaGUIController {
    @FXML private GridPane GridPaneTavaranTiedot;
    @FXML private ChoiceBox<String> ChoiceBoxHakuehdot;
    
    @FXML void onActionTallenna() {
        tallenna();
    }
    
    //Sekä menu -toiminto, että Lisää tavara -painike
    @FXML void onActionLisaaTavara() {
        avaaUusiTavara();
    }

    @FXML void onActionMuokkaaTavaraa() {
        avaaMuokkaaIkkuna();
    }
    

    @FXML void onActionMuokkaaTiloja() {
        avaaMuokkaaTiloja();
    }
    
    @FXML void onActionPoista() {
        avaaPoistaVahvistus();
    }
    
    
    @FXML void onMouseReleasedHakuehdot() {
        avaaHakuehtolista();
    }
    
    @FXML void onActionNaytaSisalto() {
        avaaSisalto();
    }
    
    @FXML void onActionLisaaTagi() {
        avaaTaginLisays();
    }
    
    

    /**************Toteutukset****************/
    
    /**
     * Tietojen tallennus, ei vielä toimiva.
     */
    public static void tallenna() {
        Dialogs.showMessageDialog("Tallennetetaan! Mutta ei toimi vielä");
    }
    
    
    /**
     * Toteutetaan Lisää tavara-painikkeen toiminta 
     * (ja uuden tavaran ikkunan avaaminen muillekin),
     * eli avataan modaalisena ikkunanan suunniteltu 
     * tyhjä ikkuna tavaran tietojen täyttämiseksi.
     */
    public static void avaaUusiTavara() {
        URL url = TavaranLisaysGUIController.class.getResource("TavaraLisaysGuiView.fxml");
        ModalController.showModal(url, null, null, null);
    }
    
    
    /**
     * Toteutetaan Muokkaa Tavaraa -menuvalinnan toiminta,
     * eli avataan modaalinen ikkuna, jossa valitun tavaran tiedot
     * täytettynä.
     */
    public void avaaMuokkaaIkkuna() {
        // Täydennä toimimaan: tietojen haku GridPane -komponentista ja aseta ne lähtötiedoiksi, 
        //String alkupTiedot = GridPaneTavaranTiedot.getAccessibleText();
        //System.out.println(alkupTiedot);
        URL url = TavaranLisaysGUIController.class.getResource("TavaraLisaysGuiView.fxml");
        ModalController.showModal(url, null, null, null);
    }
    
    
    /**
     * Toteutetaan Muokkaa Tiloja -menuvalinnan toiminta, 
     * eli avataan modaalisena tiloja varten suunniteltu ikkuna.
     * Ei vielä toteuteta muokkausta.
     */
    public void avaaMuokkaaTiloja() {
        URL url = TilanTiedotGUIController.class.getResource("TilanTiedotGUIView.fxml");
        ModalController.showModal(url, null, null, null);
    }
    
    
    /**
     * Avataan hakuehtolista näkyville. Toistaiseksi ei toimi.
     * Pohditaan minkälainen komponentti paras (ChoiceBox vai mallin ComboBoxChooser tjsp.)
     */
    public void avaaHakuehtolista() {
        Dialogs.showMessageDialog("Avataan hakuehtolista, mutta ei toimi vielä");
        
    }
    
    
    /**
     * Toteutetaan Näytä Sisältö-painikkeen toiminta,
     * eli avataan modaalisena ikkunana suunniteltu sisältöikkuna.
     */
    private void avaaSisalto() {
        URL url = TavaranSisaltoGUIController.class.getResource("TavaranSisaltoGUIView.fxml");
        ModalController.showModal(url, null, null, null);  
    }    
    
    
    /**
     * Toteutetaan Lisää Täg-painikkeen toiminta,
     * eli avataan modaalinen ikkuna, joka pyytää uuden 
     * tägin nimen.
     */
    public void avaaTaginLisays() {
        URL url = LisaaTagGUIController.class.getResource("LisaaTagGUIView.fxml");
        ModalController.showModal(url, null, null, null); 
    }
    
    
    /**
     * Kysytään käyttäjältä halutaanko valittu asia varmasti poistaa.
     */
    public void avaaPoistaVahvistus() {
        boolean vastaus = Dialogs.showQuestionDialog("Poisto?",
                "Haluatko poistaa: ", "Kyllä", "Ei");
        if (vastaus == true) {
            Dialogs.showMessageDialog("Poistetaan, mutta ei toimi vielä");
        }
    }
}

